`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    15:04:21 04/15/2014 
// Design Name: 
// Module Name:    acc_dummy 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module acc_dummy_6_6(
	 input 			i_clk,
	 input			i_rst,
	 input			i_start,
	 input [31:0] 	i_opt,
	 output reg			o_rdy,
    input [31:0] acc_in_0,
    input [31:0] acc_in_1,
    input [31:0] acc_in_2,
	 input [31:0] acc_in_3,
	 input [31:0] acc_in_4,
	 input [31:0] acc_in_5,
    output reg [31:0] acc_out_0,
	 output reg [31:0] acc_out_1,
	 output reg [31:0] acc_out_2,
	 output reg [31:0] acc_out_3,
	 output reg [31:0] acc_out_4,
	 output reg [31:0] acc_out_5
    );
	 
	reg [31:0] counter;
	reg [31:0] input_buffer [0:5];
	reg start_state;
	always @(posedge i_clk or posedge i_rst)
	begin
		if(i_rst)
		begin
			counter = 'h0;
			
			acc_out_0 = 'h0;
			acc_out_1 = 'h0;
			acc_out_2 = 'h0;
			acc_out_3 = 'h0;
			acc_out_4 = 'h0;
			acc_out_5 = 'h0;
			o_rdy = 'h0;
			start_state = 'h0;
		end
		else if(start_state) //TODO: warning, possible bug, start state more important then start_i
		begin
			if (counter > 0)
				begin
					counter = counter - 1;
					o_rdy = 'h0;
				end
			else
			begin
				acc_out_0 = input_buffer[0];
				acc_out_1 = input_buffer[1];
				acc_out_2 = input_buffer[2];
				acc_out_3 = input_buffer[3];
				acc_out_4 = input_buffer[4];
				acc_out_5 = input_buffer[5];
				counter = 0;
				o_rdy = 1;
				start_state = 0;
			end
		end
		else if(i_start)
		begin
			counter = i_opt;
			input_buffer[0] = acc_in_0;
			input_buffer[1] = acc_in_1;
			input_buffer[2] = acc_in_2;
			input_buffer[3] = acc_in_3;
			input_buffer[4] = acc_in_4;
			input_buffer[5] = acc_in_5;
			o_rdy = 0;
			start_state = 1;
		end
		else
			o_rdy = 0;
	end

endmodule

module acc_dummy_5_3(
	 input 			i_clk,
	 input			i_rst,
	 input			i_start,
	 input [31:0] 	i_opt,
	 output reg			o_rdy,
    input [31:0] acc_in_0,
    input [31:0] acc_in_1,
    input [31:0] acc_in_2,
	 input [31:0] acc_in_3,
	 input [31:0] acc_in_4,
    output reg [31:0] acc_out_0,
	 output reg [31:0] acc_out_1,
	 output reg [31:0] acc_out_2
    );
	 
	reg [31:0] counter;
	reg [31:0] input_buffer [0:4];
	reg start_state;
	always @(posedge i_clk or posedge i_rst)
	begin
		if(i_rst)
		begin
			counter = 'h0;
			
			acc_out_0 = 'h0;
			acc_out_1 = 'h0;
			acc_out_2 = 'h0;
			o_rdy = 'h0;
			start_state = 'h0;
		end
		else if(start_state) //TODO: warning, possible bug, start state more important then start_i
		begin
			if (counter > 0)
				begin
					counter = counter - 1;
					o_rdy = 'h0;
				end
			else
			begin
				acc_out_0 = input_buffer[0] + input_buffer[3];
				acc_out_1 = input_buffer[1] + input_buffer[4];
				acc_out_2 = input_buffer[2] + input_buffer[1];
				counter = 0;
				o_rdy = 1;
				start_state = 0;
			end
		end
		else if(i_start)
		begin
			counter = i_opt;
			input_buffer[0] = acc_in_0;
			input_buffer[1] = acc_in_1;
			input_buffer[2] = acc_in_2;
			input_buffer[3] = acc_in_3;
			input_buffer[4] = acc_in_4;
			o_rdy = 0;
			start_state = 1;
		end
		else
			o_rdy = 0;
	end

endmodule

module acc_dummyV2_6_6(
	 input 			i_clk,
	 input			i_rst,
	 input			i_start,
	 input [31:0] 	i_opt,
	 output reg			o_rdy,
    input [31:0] acc_in_0,
    input [31:0] acc_in_1,
    input [31:0] acc_in_2,
	 input [31:0] acc_in_3,
	 input [31:0] acc_in_4,
	 input [31:0] acc_in_5,
    output reg [31:0] acc_out_0,
	 output reg [31:0] acc_out_1,
	 output reg [31:0] acc_out_2,
	 output reg [31:0] acc_out_3,
	 output reg [31:0] acc_out_4,
	 output reg [31:0] acc_out_5
    );
	 
	reg [31:0] counter;
	reg [31:0] input_buffer [0:5];
	reg start_state;
	always @(posedge i_clk or posedge i_rst)
	begin
		if(i_rst)
		begin
			counter = 'h0;
			
			acc_out_0 = 'h0;
			acc_out_1 = 'h0;
			acc_out_2 = 'h0;
			acc_out_3 = 'h0;
			acc_out_4 = 'h0;
			acc_out_5 = 'h0;
			o_rdy = 'h0;
			start_state = 'h0;
		end
		else if(start_state) //TODO: warning, possible bug, start state more important then start_i
		begin
			if (counter > 0)
				begin
					counter = counter - 1;
					o_rdy = 'h0;
				end
			else
			begin
				acc_out_0 = input_buffer[0];
				acc_out_1 = input_buffer[1];
				acc_out_2 = input_buffer[2];
				acc_out_3 = input_buffer[3];
				acc_out_4 = input_buffer[4];
				acc_out_5 = input_buffer[5];
				counter = 0;
				o_rdy = 1;
				start_state = 0;
			end
		end
		else if(i_start)
		begin
			counter = i_opt;
			input_buffer[0] = acc_in_0 + acc_in_1;
			input_buffer[1] = acc_in_1 + acc_in_2;
			input_buffer[2] = acc_in_2 - acc_in_3;
			input_buffer[3] = acc_in_3 + acc_in_4;
			input_buffer[4] = acc_in_4 - acc_in_5;
			input_buffer[5] = acc_in_5 + acc_in_0;
			o_rdy = 0;
			start_state = 1;
		end
		else
			o_rdy = 0;
	end

endmodule
module acc_dummy_4_4(
	 input 			i_clk,
	 input			i_rst,
	 input			i_start,
	 input [31:0] 	i_opt,
	 output reg			o_rdy,
    
	input [31:0] acc_in_0,
    input [31:0] acc_in_1,
    input [31:0] acc_in_2,
	 input [31:0] acc_in_3,
	 
	 output [31:0] acc_out_0,
	 output [31:0] acc_out_1,
	 output [31:0] acc_out_2,
	 output [31:0] acc_out_3
	 );
	 assign acc_out_0 = acc_in_0 & i_opt;
	 assign acc_out_1 = acc_in_1 & i_opt;
	 assign acc_out_2 = acc_in_2 & i_opt;
	 assign acc_out_3 = acc_in_3 & i_opt;
	 
	 always @(posedge i_clk)
		o_rdy = !i_start;
endmodule


module acc_dummyV2_4_4(
	 input 			i_clk,
	 input			i_rst,
	 input			i_start,
	 input [31:0] 	i_opt,
	 output reg			o_rdy,
    input [31:0] acc_in_0,
    input [31:0] acc_in_1,
    input [31:0] acc_in_2,
	 input [31:0] acc_in_3,
	 
	 output reg [31:0] acc_out_0,
	 output reg [31:0] acc_out_1,
	 output reg [31:0] acc_out_2,
	 output reg [31:0] acc_out_3
	 
	 );
	  
	reg [31:0] counter;
	reg [31:0] input_buffer [0:5];
	reg start_state;
	always @(posedge i_clk or posedge i_rst)
	begin
		if(i_rst)
		begin
			counter = 'h0;
			
			acc_out_0 = 'h0;
			acc_out_1 = 'h0;
			acc_out_2 = 'h0;
			acc_out_3 = 'h0;
			o_rdy = 'h0;
			start_state = 'h0;
		end
		else if(start_state) //TODO: warning, possible bug, start state more important then start_i
		begin
			if (counter > 0)
				begin
					counter = counter - 1;
					o_rdy = 'h0;
				end
			else
			begin
				acc_out_0 = input_buffer[0] + input_buffer[1];
				acc_out_1 = input_buffer[1] + input_buffer[2];
				acc_out_2 = input_buffer[2] - input_buffer[1];
				acc_out_3 = input_buffer[3] - input_buffer[0];
				counter = 0;
				o_rdy = 1;
				start_state = 0;
			end
		end
		else if(i_start)
		begin
			counter = i_opt;
			input_buffer[0] = acc_in_0;
			input_buffer[1] = acc_in_1;
			input_buffer[2] = acc_in_2;
			input_buffer[3] = acc_in_3;
			o_rdy = 0;
			start_state = 1;
		end
		else
			o_rdy = 0;
	end

endmodule

module acc_dummy_1_4(
	 input 			i_clk,
	 input			i_rst,
	 input			i_start,
	 input [31:0] 	i_opt,
	 output reg			o_rdy,
    input [31:0] acc_in_0,
    
	 output reg [31:0] acc_out_0,
	 output reg [31:0] acc_out_1,
	 output reg [31:0] acc_out_2,
	 output reg [31:0] acc_out_3
	 
	 );
	 
	reg [31:0] counter;
	reg [31:0] input_buffer [0:5];
	reg start_state;
	always @(posedge i_clk or posedge i_rst)
	begin
		if(i_rst)
		begin
			counter = 'h0;
			
			acc_out_0 = 'h0;
			acc_out_1 = 'h0;
			acc_out_2 = 'h0;
			acc_out_3 = 'h0;
			o_rdy = 'h0;
			start_state = 'h0;
		end
		else if(start_state) //TODO: warning, possible bug, start state more important then start_i
		begin
			if (counter > 0)
				begin
					counter = counter - 1;
					o_rdy = 'h0;
				end
			else
			begin
				acc_out_0 = input_buffer[0];
				acc_out_1 = input_buffer[1];
				acc_out_2 = input_buffer[2];
				acc_out_3 = input_buffer[3];
				counter = 0;
				o_rdy = 1;
				start_state = 0;
			end
		end
		else if(i_start)
		begin
			counter = i_opt;
			input_buffer[0] = acc_in_0 * 2;
			input_buffer[1] = acc_in_0 + 8;
			input_buffer[2] = acc_in_0 - 4;
			input_buffer[3] = acc_in_0;
			o_rdy = 0;
			start_state = 1;
		end
		else
			o_rdy = 0;
	end
	
endmodule


module acc_dummyV3_4_1(
	 input 			i_clk,
	 input			i_rst,
	 input			i_start,
	 input [31:0] 	i_opt,
	 output reg			o_rdy,
    input [31:0] acc_in_0,
    input [31:0] acc_in_1,
    input [31:0] acc_in_2,
	 input [31:0] acc_in_3,
    output reg [31:0] acc_out_0
    );
	 
	reg [31:0] counter;
	reg [31:0] input_buffer [0:3];
	reg start_state;
	always @(posedge i_clk or posedge i_rst)
	begin
		if(i_rst)
		begin
			counter = 'h0;
			
			acc_out_0 <= 'h0;
			o_rdy <= 'h0;
			start_state = 'h0;
		end
		else if(start_state)
		begin
			if (counter > 0)
				begin
					counter = counter - 1;
					o_rdy <= 'h0;
				end
			else
			begin
				acc_out_0 <= input_buffer[0] + input_buffer[1] + input_buffer[2] + input_buffer[3];
				counter = i_opt;
				o_rdy <= 1;
			end
		end
		else if(i_start)
		begin
			counter = i_opt;
			input_buffer[0] = acc_in_0;
			input_buffer[1] = acc_in_1;
			input_buffer[2] = acc_in_2;
			input_buffer[3] = acc_in_3;
			o_rdy <= 0;
			start_state = 1;
		end
		else
			o_rdy <= 0;
	end

endmodule



module acc_dummyV2_4_1(
	 input 			i_clk,
	 input			i_rst,
	 input			i_start,
	 input [31:0] 	i_opt,
	 output reg			o_rdy,
    input [31:0] acc_in_0,
    input [31:0] acc_in_1,
    input [31:0] acc_in_2,
	 input [31:0] acc_in_3,
    output reg [31:0] acc_out_0
    );
	 
	reg [31:0] counter;
	reg [31:0] counter2;
	reg [31:0] input_buffer [0:3];
	reg start_state;
	always @(posedge i_clk or posedge i_rst)
	begin
		if(i_rst)
		begin
			counter = 'h0;
			counter2 = 'h0;
			acc_out_0 = 'h0;
			o_rdy <= 'h0;
			start_state = 'h0;
		end
		else if(start_state)
		begin
			if (counter < i_opt )
				begin
					counter = counter +1;
					counter2 = counter2 +1;
					o_rdy <= 'h0;
				end
			else
			begin
				acc_out_0 = counter2;
				counter = 0;
				o_rdy <= 1;
			end
		end
		else if(i_start)
		begin
			counter = 0;
			counter2 = 'h0;
			input_buffer[0] = acc_in_0;
			input_buffer[1] = acc_in_1;
			input_buffer[2] = acc_in_2;
			input_buffer[3] = acc_in_3;
			o_rdy <= 0;
			start_state = 1;
		end
		else
			o_rdy <= 0;
	end

endmodule

module acc_dummy_2_2(
	 input 			i_clk,
	 input			i_rst,
	 input			i_start,
	 input [31:0] 	i_opt,
	 output reg			o_rdy,
    input [31:0] acc_in_0,
    input [31:0] acc_in_1,
    output reg [31:0] acc_out_0,
	 output reg [31:0] acc_out_1
	 );
	 
	reg [31:0] counter;
	reg [31:0] input_buffer [0:5];
	reg start_state;
	always @(posedge i_clk or posedge i_rst)
	begin
		if(i_rst)
		begin
			counter = 'h0;
			
			acc_out_0 = 'h0;
			acc_out_1 = 'h0;
			o_rdy = 'h0;
			start_state = 'h0;
		end
		else if(start_state) //TODO: warning, possible bug, start state more important then start_i
		begin
			if (counter > 0)
				begin
					counter = counter - 1;
					o_rdy = 'h0;
				end
			else
			begin
				acc_out_0 = input_buffer[0];
				acc_out_1 = input_buffer[1];
				counter = 0;
				o_rdy = 1;
				start_state = 0;
			end
		end
		else if(i_start)
		begin
			counter = i_opt;
			input_buffer[0] = acc_in_0;
			input_buffer[1] = acc_in_1;
			o_rdy = 0;
			start_state = 1;
		end
		else
			o_rdy = 0;
	end

endmodule 

module acc_dummy_1_1(
		input 			i_clk,
		input			i_rst,
		input			i_start,
		input [31:0] 	i_opt,
		output reg			o_rdy,
		input [31:0] acc_in_0,
		output reg [31:0] acc_out_0
    );
	 
		always @(posedge i_clk)
		begin
			if(i_rst)
			begin
				acc_out_0 = 'h0;
				o_rdy = 'h0;
			end
			else
			begin
				if(o_rdy)
					o_rdy = 0;
				if(i_start)
				begin
					acc_out_0 = acc_in_0;
					o_rdy = 1;
				end
			end
		end

endmodule 

module acc_dummy_3_1(
		input 			i_clk,
		input			i_rst,
		input			i_start,
		input [31:0] 	i_opt,
		output reg			o_rdy,
		input [31:0] acc_in_0,
		input [31:0] acc_in_1,
		input [31:0] acc_in_2,
		output reg [31:0] acc_out_0
    );
	 
		always @(posedge i_clk)
		begin
			if(i_rst)
			begin
				acc_out_0 = 'h0;
				o_rdy = 'h0;
			end
			else
			begin
				if(o_rdy)
					o_rdy = 0;
				if(i_start)
				begin
					acc_out_0 = acc_in_0;
					o_rdy = 1;
				end
			end
		end

endmodule 