`timescale 1ns / 1ps

////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer:
//
// Create Date:   17:55:48 05/03/2014
// Design Name:   wb_arbiter
// Module Name:   D:/SHMAC/ISEprojects/AmberWrapper/arbiter_TB.v
// Project Name:  AmberWrapper
// Target Device:  
// Tool versions:  
// Description: 
//
// Verilog Test Fixture created by ISE for module: wb_arbiter
//
// Dependencies:
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
////////////////////////////////////////////////////////////////////////////////

module arbiter_TB;

	// Inputs
	reg i_rst;
	reg [127:0] i_wbm_dat;
	reg i_wbm_ack;
	reg i_wbm_err;
	reg [31:0] in0_o_wbm_adr;
	reg [15:0] in0_o_wbm_sel;
	reg in0_o_wbm_we;
	reg [127:0] in0_o_wbm_dat;
	reg in0_o_wbm_cyc;
	reg in0_o_wbm_stb;
	reg [31:0] in1_o_wbm_adr;
	reg [15:0] in1_o_wbm_sel;
	reg in1_o_wbm_we;
	reg [127:0] in1_o_wbm_dat;
	reg in1_o_wbm_cyc;
	reg in1_o_wbm_stb;

	// Outputs
	wire [31:0] o_wbm_adr;
	wire [15:0] o_wbm_sel;
	wire o_wbm_we;
	wire [127:0] o_wbm_dat;
	wire o_wbm_cyc;
	wire o_wbm_stb;
	wire [127:0] in0_i_wbm_dat;
	wire in0_i_wbm_ack;
	wire in0_i_wbm_err;
	wire [127:0] in1_i_wbm_dat;
	wire in1_i_wbm_ack;
	wire in1_i_wbm_err;

	// Instantiate the Unit Under Test (UUT)
	wb_arbiter uut (
		.i_rst(i_rst), 
		.o_wbm_adr(o_wbm_adr), 
		.o_wbm_sel(o_wbm_sel), 
		.o_wbm_we(o_wbm_we), 
		.i_wbm_dat(i_wbm_dat), 
		.o_wbm_dat(o_wbm_dat), 
		.o_wbm_cyc(o_wbm_cyc), 
		.o_wbm_stb(o_wbm_stb), 
		.i_wbm_ack(i_wbm_ack), 
		.i_wbm_err(i_wbm_err), 
		.in0_o_wbm_adr(in0_o_wbm_adr), 
		.in0_o_wbm_sel(in0_o_wbm_sel), 
		.in0_o_wbm_we(in0_o_wbm_we), 
		.in0_i_wbm_dat(in0_i_wbm_dat), 
		.in0_o_wbm_dat(in0_o_wbm_dat), 
		.in0_o_wbm_cyc(in0_o_wbm_cyc), 
		.in0_o_wbm_stb(in0_o_wbm_stb), 
		.in0_i_wbm_ack(in0_i_wbm_ack), 
		.in0_i_wbm_err(in0_i_wbm_err), 
		.in1_o_wbm_adr(in1_o_wbm_adr), 
		.in1_o_wbm_sel(in1_o_wbm_sel), 
		.in1_o_wbm_we(in1_o_wbm_we), 
		.in1_i_wbm_dat(in1_i_wbm_dat), 
		.in1_o_wbm_dat(in1_o_wbm_dat), 
		.in1_o_wbm_cyc(in1_o_wbm_cyc), 
		.in1_o_wbm_stb(in1_o_wbm_stb), 
		.in1_i_wbm_ack(in1_i_wbm_ack), 
		.in1_i_wbm_err(in1_i_wbm_err)
	);

	initial begin
		// Initialize Inputs
		i_rst = 1;
		i_wbm_dat = 128'hbabebabebabebabebabebabebabebabe;
		i_wbm_ack = 1;
		i_wbm_err = 1;
		in0_o_wbm_adr = 'haaaaaaaa;
		in0_o_wbm_sel = 'haaaa;
		in0_o_wbm_we = 0;
		in0_o_wbm_dat = 128'hcafecafecafecafecafecafecafecafe;
		in0_o_wbm_cyc = 0;
		in0_o_wbm_stb = 0;
		in1_o_wbm_adr = 'h55555555;
		in1_o_wbm_sel = 'h5555;
		in1_o_wbm_we = 1;
		in1_o_wbm_dat = 128'hf0f0f0f0f0f0f0f0f0f0f0f0f0f0f0f0;
		in1_o_wbm_cyc = 0;
		in1_o_wbm_stb = 1;


		// Wait 100 ns for global reset to finish
		#100;
		i_rst = 0;
		
		#10;
		in0_o_wbm_cyc = 1;
		in1_o_wbm_cyc = 0;
		#10;
		in0_o_wbm_cyc = 0;
		in1_o_wbm_cyc = 1;
		
		#10;
		in0_o_wbm_cyc = 1;
		in1_o_wbm_cyc = 1;
		
		#10;
		in0_o_wbm_cyc = 1;
		in1_o_wbm_cyc = 0;
		
		#10;
		in0_o_wbm_cyc = 1;
		in1_o_wbm_cyc = 1;
		
		#10;
		in0_o_wbm_cyc = 0;
		in1_o_wbm_cyc = 1;
		
		#10;
		in0_o_wbm_cyc = 1;
		in1_o_wbm_cyc = 1;
		
		#10;
		in0_o_wbm_cyc = 0;
		in1_o_wbm_cyc = 0;
		
		
        
		// Add stimulus here

	end
      
endmodule

