`timescale 1ns / 1ps

////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer:
//
// Create Date:   15:09:07 05/16/2014
// Design Name:   amber_system_floop_acc_dummy_4_4
// Module Name:   D:/AmberWrapper/genSysTB.v
// Project Name:  AmberWrapper
// Target Device:  
// Tool versions:  
// Description: 
//
// Verilog Test Fixture created by ISE for module: amber_system_floop_acc_dummy_4_4
//
// Dependencies:
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
////////////////////////////////////////////////////////////////////////////////
`define CYC 16.667 //ca 60 MHZ
`define MEMSIZE 8
module genSysTB;

	// Inputs
	reg i_clk;
	reg i_rst;
	reg i_irq;
	reg i_system_rdy;
	reg [127:0] i_wb_dat;
	reg i_wb_ack;
	reg i_wb_err;

	// Outputs
	wire [31:0] o_wb_adr;
	wire [15:0] o_wb_sel;
	wire o_wb_we;
	wire [127:0] o_wb_dat;
	wire o_wb_cyc;
	wire o_wb_stb;
	wire o_ld_excl;

	reg [127:0] wbMem[0:`MEMSIZE-1]; 
	reg [127:0]	wbRec[0:`MEMSIZE-1];
	`include "wbMemTB.v"
	integer i;
	
	// Instantiate the Unit Under Test (UUT)
	amber_system_floop_acc_dummy_6_6 uut (
		.i_clk(i_clk), 
		.i_rst(i_rst), 
		.i_irq(i_irq), 
		.i_system_rdy(i_system_rdy), 
		.o_wb_adr(o_wb_adr), 
		.o_wb_sel(o_wb_sel), 
		.o_wb_we(o_wb_we), 
		.i_wb_dat(i_wb_dat), 
		.o_wb_dat(o_wb_dat), 
		.o_wb_cyc(o_wb_cyc), 
		.o_wb_stb(o_wb_stb), 
		.i_wb_ack(i_wb_ack), 
		.i_wb_err(i_wb_err), 
		.o_ld_excl(o_ld_excl)
	);
	always
	begin
		//#16.667 clk = ~clk;
		#(0.5*`CYC) i_clk = ~i_clk;
	end
	
	//wb slave response
	always @(posedge o_wb_stb)begin
		#(0.5*`CYC);
		if(!o_wb_we)
		begin
			if(o_wb_adr[7:4]<`MEMSIZE && !(o_wb_adr[31:28] == 2))
			begin
				i_wb_dat = wbMem[o_wb_adr[7:4]];
				#(0.6*`CYC)	i_wb_ack = 1;
			end
			else if(o_wb_adr == 32'h20000000)
			begin
				i_wb_dat = 128'h2;//slave(1) / master(2) select
				#(0.6*`CYC) i_wb_ack = 1;
			end
			else
			begin
				i_wb_dat = 128'h0;
				#(0.6*`CYC)	i_wb_ack = 1;
			end
		end
		else
		begin
			if(o_wb_adr[7:4]<`MEMSIZE)
				wbRec[o_wb_adr[7:4]]	= o_wb_dat;
			#(0.6*`CYC) i_wb_ack = 1;
		end
	end
	always @(negedge o_wb_stb)begin
		i_wb_ack = 0;
	end
	
	initial begin
		// Initialize Inputs
		i_clk = 1;
		i_rst = 1;
		i_irq = 0;
		i_system_rdy = 0;
		i_wb_dat = 0;
		i_wb_ack = 0;
		i_wb_err = 0;

		// Wait 100 ns for global reset to finish
		#(2*`CYC) i_rst = 0;
        
		
	end
      
endmodule

