//Script generated defines 
`define ACC_INPUTS		4
`define ACC_OUTPUTS		4

`define OUTQUEUESIZE		8
`define INQUEUESIZE		8

module wbm_buffer_acc_dummy_4_4
	(
	input i_clk,
	input i_rst,
	
	input		[31:0]		i_input_adr,
	input		[31:0]		i_output_adr,
	input					i_set_adr,
	input 					i_read_input,
	input 					i_write_output,
	input					i_last_read,
	output 					o_stall,
	//wishbone IF here
	output reg	[31:0]  	o_wbm_adr,
	output reg 	[15:0]		o_wbm_sel,
	output reg        		o_wbm_we,
	input 		[127:0]		i_wbm_dat,
	output	 	[127:0]		o_wbm_dat,
	output reg        		o_wbm_cyc,
	output reg         		o_wbm_stb,
	input          			i_wbm_ack,
	input          			i_wbm_err,
	//script generated interface
	output reg	[31:0]	acc_in_0,
	output reg	[31:0]	acc_in_1,
	output reg	[31:0]	acc_in_2,
	output reg	[31:0]	acc_in_3,
	input		[31:0]	acc_out_0,
	input		[31:0]	acc_out_1,
	input		[31:0]	acc_out_2,
	input		[31:0]	acc_out_3
	);
	
	//regs
	reg	[31:0]	input_adr;
	reg	[31:0]	output_adr;
	reg	[31:0]	output_buffer	[0:`ACC_OUTPUTS-1];
	reg	[31:0]	output_fifo		[0:`OUTQUEUESIZE-1];
	reg	[31:0]	input_fifo		[0:`INQUEUESIZE-1];
	reg	[31:0]	read_buffer		[0:3];
	reg	[31:0]	write_buffer	[0:3];
	integer		out_i;	//TODO generate size of these?
	integer		in_i;
	reg			new_dataout;
	reg			new_datain;
	reg			read;
	reg			first_read;
	reg			read_stall;
	reg			write_stall;
	reg 		write;
	integer i;
	
	assign o_stall = read_stall || write_stall;
	assign o_wbm_dat [31:0] = write_buffer[0];
	assign o_wbm_dat [63:32] = write_buffer[1];
	assign o_wbm_dat [95:64] = write_buffer[2];
	assign o_wbm_dat [127:96] = write_buffer[3];
	
	always @(posedge i_clk or posedge i_rst)
	begin
		if (i_rst)
		begin
			for (i=0; i<`ACC_OUTPUTS; i=i+1)
				output_buffer[i] = 'h0;
			for (i=0; i<4; i=i+1)
				write_buffer[i] = 'h0;
			for (i=0; i<`OUTQUEUESIZE; i=i+1)
				output_fifo[i] = 'h0;
			for (i=0; i<`INQUEUESIZE; i=i+1)
				input_fifo[i] = 'h0;
			out_i = 'h0;
			in_i = 'h0;
			new_dataout = 'h0;
			new_datain = 'h0;
			read_stall = 'h1;
			write_stall = 'h0;
			read = 'h0;
			first_read = 'h0;
			input_adr = 'h0;
			output_adr = 'h0;
			//wb rst
			o_wbm_adr <= 'h0;
			o_wbm_sel <= 'h0;
			o_wbm_we <= 'h0;
			o_wbm_cyc <= 'h0;
			o_wbm_stb <= 'h0;
			write = 'h0;
		end//rst
		else
		begin
			if(i_set_adr)
			begin
				input_adr = i_input_adr;
				output_adr = i_output_adr;
				read_stall = 1;
				read = 1;
				first_read = 1;
			end
			else if (!o_stall)
			begin
				if(i_read_input)
				begin
					acc_in_0 <= input_fifo[0];
					acc_in_1 <= input_fifo[1];
					acc_in_2 <= input_fifo[2];
					acc_in_3 <= input_fifo[3];
					for(i = 0; i < `INQUEUESIZE-`ACC_INPUTS; i = i+1)
						input_fifo[i] = input_fifo[i+`ACC_INPUTS];
					in_i = in_i - `ACC_INPUTS;
					read_stall = 1;
				end //read input
				if(i_write_output)
				begin
					write_stall = 1;
					new_dataout = 1;
					output_buffer[0] = acc_out_0;
					output_buffer[1] = acc_out_1;
					output_buffer[2] = acc_out_2;
					output_buffer[3] = acc_out_3;
				end//write out			
			end//if not stalls
			else//stalls
			begin
				if(write_stall)
				begin
					if(new_dataout)
					begin
						for(i = 0; i < `ACC_OUTPUTS; i = i+1)
						begin
							output_fifo[out_i] = output_buffer[i];
							out_i = out_i + 1;
						end
						new_dataout = 0;
					end // new dataout
					if (write)
					begin
						//write to wbm
						if(o_wbm_stb == 0)
						begin
							o_wbm_adr <= output_adr;
							o_wbm_sel <= 16'hffff;
							o_wbm_cyc <= 1;
							o_wbm_stb <= 1;
							o_wbm_we <= 1;
						end//strobe == 0
						else if(i_wbm_ack)
							begin
								output_adr = output_adr + 'h10;
								write = 0;
								for (i=0; i<4; i=i+1)
									write_buffer[i] = 'h0;
								o_wbm_adr <= 32'h0000;
								o_wbm_sel <= 16'h0000;
								o_wbm_cyc <= 0;
								o_wbm_stb <= 0;
								o_wbm_we <= 0;
							end//ack
					end//write
					else if(out_i > 3)
					begin
						for(i = 0; i < 4; i = i+1)
							write_buffer[i] = output_fifo[i];
						for(i = 0; i < `OUTQUEUESIZE-4; i = i+1)
							output_fifo[i] = output_fifo[i+4];
						out_i = out_i - 4;
						write = 1;
					end
					else if(i_last_read)
					begin
						case(out_i)
							'h0: write_stall = 0;
							'h1:
							begin
								write_buffer[0] = output_fifo[0];
								write_buffer[1] = 32'h0;
								write_buffer[2] = 32'h0;
								write_buffer[3] = 32'h0;
								write = 1;
							end
							'h2:
							begin
								write_buffer[0] = output_fifo[0];
								write_buffer[1] = output_fifo[1];
								write_buffer[2] = 32'h0;
								write_buffer[3] = 32'h0;
								write = 1;
							end
							'h3:
							begin
								write_buffer[0] = output_fifo[0];
								write_buffer[1] = output_fifo[1];
								write_buffer[2] = output_fifo[2];
								write_buffer[3] = 32'h0;
								write = 1;
							end
						endcase
						out_i = 0;
					end//last_read
					else
						write_stall = 0;
				end//o_write_stall
				else	//o_read_stall
				begin
					if(first_read)
					begin
						if(read)
						begin
							if(!o_wbm_stb)
							begin
								o_wbm_adr <= input_adr;
								o_wbm_sel <= 16'hffff;
								o_wbm_cyc <= 1;
								o_wbm_stb <= 1;
								o_wbm_we <= 0;
							end//!strobe
							else if(i_wbm_ack)
							begin
								o_wbm_adr <= 0;
								o_wbm_sel <= 16'h0;
								o_wbm_cyc <= 0;
								o_wbm_stb <= 0;
								o_wbm_we <= 0;
								
								read_buffer[0] = i_wbm_dat[31:0];
								read_buffer[1] = i_wbm_dat[63:32];
								read_buffer[2] = i_wbm_dat[95:64];
								read_buffer[3] = i_wbm_dat[127:96];
								input_adr = input_adr + 'h10;
								new_datain = 1;
								read = 0;
							end
							
						end//read
						else if(new_datain)
						begin
							for(i = 0; i < 4; i = i + 1)
							begin
								input_fifo[in_i] = read_buffer[i];
								in_i = in_i + 1;
							end
							new_datain = 0;
							if(in_i >= `ACC_INPUTS || i_last_read)
								read_stall = 0;
							else
								read = 1;
						end
						else if(in_i < `ACC_INPUTS)
							read = 1;
						else
							read_stall = 0;
					end//first read
				end//read_stall
			end//else stalls
		end//rst else
	end//posedge i_clk

endmodule

