
 //start of generated section from template file
 	reg [31:0] 	acc_in [0:(`ACC_INPUTS - 1)];
 	reg [31:0] 	acc_out[0:(`ACC_OUTPUTS - 1)];
 	reg [31:0] 	acc_opt;
	wire 		acc_poll;
	

 #0 

 	
 	reg acc_start;
 	wire acc_rdy;
	integer i;
	
	assign acc_poll = ((!acc_start) && (acc_rdy || acc_poll));
	
#1 
 	.i_clk (i_clk),
 	.i_rst (i_rst),
 	.i_start (acc_start),
 	.i_opt (acc_opt),
 	.o_rdy (acc_rdy),
#2 
 );
 //end of generated section
 
 #3 
 
 ////start of generated section from template file
 
  always @(posedge acc_rdy)
 begin
#4			
 end
 
always @ ( posedge i_clk )
	if(i_rst)
	begin
 		cache_control <= 3'b000;
 		cacheable_area <= 32'h0;
 		updateable_area <= 32'h0;
 		disruptive_area <= 32'h0;
		acc_start <= 'h0;
 	end
 	else
 	begin
		if(acc_start)
			acc_start <= 0;
		if ( !i_core_stall )         
 		begin
 			if ( i_copro_operation == 2'd2 )
 				if (i_copro_num == 'd14) //TAG_ACC
				begin
					if(i_copro_crn == 4'hf)
					begin
						acc_opt <= i_copro_write_data[31:0];
						acc_start <= 1;
					end
					if (i_copro_crn <= (`ACC_INPUTS))
						acc_in[i_copro_crn] <= i_copro_write_data[31:0];
				end
 				else
 					case ( i_copro_crn )
 						 4'd2: cache_control   <= i_copro_write_data[2:0];
 						 4'd3: cacheable_area  <= i_copro_write_data[31:0];
 						 4'd4: updateable_area <= i_copro_write_data[31:0];
 						 4'd5: disruptive_area <= i_copro_write_data[31:0];
 					endcase
 		end
 	end
	
// Flush the cache
assign copro15_reg1_write = !i_core_stall && i_copro_operation == 2'd2 && i_copro_crn == 4'd1 && i_copro_num == 'd15;
 
 // ---------------------------
 // Register Reads   
 // ---------------------------
always @ ( posedge i_clk )        
     if ( !i_core_stall )
 		if (i_copro_num == 'd14)//TAG_ACC
 		begin
			if(i_copro_crn == 4'hf)
				o_copro_read_data <= {31'b0,acc_poll};
			else
				o_copro_read_data <= acc_out[i_copro_crn];
 		end
 		else
         case ( i_copro_crn )
             4'd0:    o_copro_read_data <= 32'h4156_0300;
             4'd2:    o_copro_read_data <= {29'd0, cache_control}; 
             4'd3:    o_copro_read_data <= cacheable_area; 
             4'd4:    o_copro_read_data <= updateable_area; 
             4'd5:    o_copro_read_data <= disruptive_area; 
             4'd6:    o_copro_read_data <= {24'd0, fault_status };
             4'd7:    o_copro_read_data <= fault_address;
             default: o_copro_read_data <= 32'd0;
         endcase
endmodule