	wire [127:0]         wb_dat_r_acc; 
	wire                 wb_ack_acc;
	wire                 wb_err_acc;
	reg                  wb_stb_acc;
	wire				 irq_acc;
    wire [15:0]			 acc = `ACC;

	assign int_sources = {26'b0,irq_acc, irq_timers, i_irq};

	#0
	  .i_clk(i_clk), 
	  .i_rst(i_rst), 
	  .i_wb_adr (o_wb_adr),
      .i_wb_sel (o_wb_sel),
      .i_wb_we  (o_wb_we),
      .o_wb_dat (wb_dat_r_acc),
      .i_wb_dat (o_wb_dat),
      .i_wb_cyc (o_wb_cyc),
      .i_wb_stb (wb_stb_acc),
      .o_wb_ack (wb_ack_acc),
      .o_wb_err (wb_err_acc),
	  .o_irq (irq_acc)
	);
	
	
	
	#1 
	
           acc[15:12]: begin
              wb_dat_r_cpu = wb_dat_r_acc;
              wb_ack_cpu = wb_ack_acc;
              wb_err_cpu = wb_err_acc;
              o_wb_stb = 0;
              wb_stb_acc = wb_stb_cpu;
           end
