import sys, getopt, os


def main(argv):
	ifType = ''
	moduleName = ''
	inputsN = 0
	outputsM = 0
	amber25Path = "../units/amber/hw/vlog/amber25/" 
	amberTilePath = "../tiles/amber_tile/"
	TilesPath = "../tiles/"
	outputPath = "../tiles/amber_tile_"
	
	
	try:
		opts, args = getopt.getopt(argv,'ht:m:i:o:')
	except getopt.GetoptError:
		print("ERROR, lacking options, Script exited.")
		print('tileGenerator.py -t <interfacetype(coproc, slave, floop)> -m <Module name> -i <nr of input ports> -o <nr of output ports>')
		sys.exit(2)
	
	if len(opts) < 4:
		print("ERROR, lacking options, Script exited.")
		print('tileGenerator.py -t <interfacetype(coproc, slave, floop)> -m <Module name> -i <nr of input ports> -o <nr of output ports>')
		sys.exit(2)
	
	for opt, arg in opts:
		if opt == '-h':
			print('tileGenerator.py -t <interfacetype(coproc, slave, floop)> -m <Module name> -i <nr of input ports> -o <nr of output ports>')
			sys.exit()
		elif opt =="-t":
			ifType = arg
		elif opt =="-m":
			moduleName = arg
		elif opt == "-i":
			inputsN = int(arg)
		elif opt == "-o":
			outputsM = int(arg)
	print( 'Interface type is "', ifType, '"')
	print( 'Accelerator module is "', moduleName, '"')
	print( 'number of input ports is:', inputsN)
	print( 'number of output ports is:', outputsM)
	#creating tile 
	
	####################################################
	###  			coproc IF generate				 ###
	####################################################
	
	if ifType == "coproc":
		outputPath = outputPath + "coprocIFM_" + moduleName + "/"
		if not os.path.exists(outputPath):
			os.makedirs(outputPath)
		
		if not os.path.exists(outputPath + "/a25_placeholder/"):
			os.makedirs(outputPath + "/a25_placeholder/")
		
		#creating tile files
		#tileregs.v
		sourceFile = open(amberTilePath + "tile_regs.v", "r")
		oFile = open(outputPath + "tile_regs.v", "w")
		
		for line in sourceFile:
			oFile.write(line)
		
		sourceFile.close()
		oFile.close()
		
		#amber_wrapper.v
		sourceFile = open(amberTilePath + "amber_wrapper.v", "r")
		oFile = open(outputPath + "amber_wrapper_" + moduleName +".v", "w")
		
		#find//ACCTAGMOD
		for line in sourceFile:
			if "//ACCTAGMOD" in line:
				break
			oFile.write(line)
		
		oFile.write("module amber_wrapper_" + moduleName + "\n")
		
		#find//ACCTAGMODDONE
		for line in sourceFile:
			if "//ACCTAGMODDONE" in line:
				break
		
		#find//ACCTAGSYS
		for line in sourceFile:
			if "//ACCTAGSYS" in line:
				break
			oFile.write(line)
			
		oFile.write("\tamber_system_" + moduleName + "\n")
		
		#find //ACCTAGSYSDONE				
		for line in sourceFile:
			if "//ACCTAGSYSDONE" in line:
				break
		
		for line in sourceFile:
			oFile.write(line)
		
		sourceFile.close()
		oFile.close()
		
		#amber_tile.vhd
		sourceFile = open(amberTilePath + "amber_tile.vhd", "r")
		oFile = open(outputPath + "amber_tile_" + moduleName +".vhd", "w")
		
		#find --ACCTAGENT
		for line in sourceFile:
			if "--ACCTAGENT" in line:
				break
			oFile.write(line)
			
		oFile.write("entity amber_tile_" + moduleName + " is\n")
		
		#find --ACCTAGENTDONE
		for line in sourceFile:
			if "--ACCTAGENT" in line:
				break
		
		#find --ACCTAGENTEND
		for line in sourceFile:
			if "--ACCTAGENTEND" in line:
				break
			oFile.write(line)
		
		oFile.write("end amber_tile_" + moduleName + ";\n\n")
		oFile.write("architecture rtl of amber_tile_" + moduleName + " is\n\n")
		
		#find --ACCTAGENTENDDONE
		for line in sourceFile:
			if "--ACCTAGENTENDDONE" in line:
				break
		
		#find --ACCTAGWRA
		for line in sourceFile:
			if "--ACCTAGWRA" in line:
				break
			oFile.write(line)
			
		oFile.write("amber_u: amber_wrapper_" + moduleName + "\n")
		
		#find --ACCTAGWRADONE
		for line in sourceFile:
			if "--ACCTAGWRADONE" in line:
				break
		
		for line in sourceFile:
			oFile.write(line)
		
		sourceFile.close()
		oFile.close()
		
		#amber_system.v
		sourceFile = open(amberTilePath + "amber_system.v", "r")
		oFile = open(outputPath + "amber_system_" + moduleName +".v", "w")
		
		#find //ACCTAGSYSINST
		for line in sourceFile:
			if "//ACCTAGSYSINST" in line:
				break
			oFile.write(line)
			
		oFile.write("module amber_system_" + moduleName + "\n")
		
		#find //ACCTAGSYSINSTDONE
		for line in sourceFile:
			if "//ACCTAGSYSINSTDONE" in line:
				break
		
		#find //ACCTAGCORE
		for line in sourceFile:
			if "//ACCTAGCORE" in line:
				break
			oFile.write(line)
			
		oFile.write("a25_core_" + moduleName + "\n")
		
		#find //ACCTAGCOREDONE
		for line in sourceFile:
			if "//ACCTAGCOREDONE" in line:
				break
				
		for line in sourceFile:
			oFile.write(line)
		#creating coprocessor file
		
		sourceFile = open(amber25Path + "a25_coprocessor.v", "r")
		templateFile = open("templates/coproc_TEMP.v", "r")
		oFile = open(outputPath + "a25_placeholder/a25_coprocessor_" + moduleName +".v", "w")
		wireOutName = "wire [31:0] acc_out_"
		
		
		#find //ACCTAGDEF
		for line in sourceFile:
			if "//ACCTAGDEF" in line:
				break
			oFile.write(line)
		
		#ACCTAGDEF found
		oFile.write("//Script generated defines \n")
		oFile.write("`define ACC_INPUTS\t\t" + str(inputsN) + "\n")
		oFile.write("`define ACC_OUTPUTS\t\t" + str(outputsM) + "\n\n")
		
		oFile.write("module a25_coprocessor_" + moduleName + "\n")
		#skip until next tag, no write
		#find //ACCTAGMOD
		for line in sourceFile:
			if "//ACCTAGMOD" in line:
				break
		#find //ACCTAGINST
		for line in sourceFile:
			if "//ACCTAGINST" in line:
				break
			oFile.write(line)
			
		#ACCTAGINST found
		#Moving to template file
		#find #0
		for line in templateFile:
			if "#0" in line:
				break
			oFile.write(line)
		
		# #0 found
		for i in range(outputsM):
			oFile.write("\t"+ wireOutName + str(i) +";\n")
			
		#find #1
		for line in templateFile:
			if "#1" in line:
				break
			oFile.write(line)
		
		# #1 found
		oFile.write("\t" + moduleName + " accelerator(\n")
		
		#find #2
		for line in templateFile:
			if "#2" in line:
				break
			oFile.write(line)
			
		# #2 found
		for i in range(inputsN):
			oFile.write("\t.acc_in_" + str(i) +" (acc_in["+ str(i) +"]),\n")
		for i in range(outputsM):
			oFile.write("\t.acc_out_" + str(i) +" (acc_out_" + str(i))
			if i == (outputsM - 1):
				oFile.write(")\n")
			else:
				oFile.write("),\n")
		
		#find #3
		for line in templateFile:
			if "#3" in line:
				break
			oFile.write(line)
			
		# #3 found, end of section
		#moving back to sourcefile
		#find //ACCTAGREGW
		for line in sourceFile:
			if "//ACCTAGREGW" in line:
				break
			oFile.write(line)
		
		#ACCTAGREGW found
		#Moving to template file
		#find #4
		for line in templateFile:
			if "#4" in line:
				break
			oFile.write(line)
		
		# #4 found
		for i in range(outputsM):
			oFile.write("\tacc_out[" + str(i) +"] <= acc_out_" + str(i) + ";\n")
				
		for line in templateFile:
			oFile.write(line)
		
		sourceFile.close()
		templateFile.close()
		oFile.close()
		
		# Generate compatible amber_core
		
		sourceFile = open(amber25Path + "a25_core.v", "r")
		oFile = open(outputPath + "a25_placeholder/a25_core_" + moduleName +".v", "w")
		
		#find //ACCTAGCOPROC
		for line in sourceFile:
			if "//ACCTAGCOPROC" in line:
				break
			oFile.write(line)
		
		oFile.write("a25_coprocessor_" + moduleName +" u_coprocessor ( \n")
		
		for line in sourceFile:
			oFile.write(line)
			
		sourceFile.close()
		oFile.close()
		
		print("Done!")
		print("Your verilog files can be found in the output folder")
	
	####################################################
	###  			slave IF generate				 ###
	####################################################
	
	elif ifType == "slave":
		outputPath = outputPath + "slaveIFM_" + moduleName + "/"
		if not os.path.exists(outputPath):
			os.makedirs(outputPath)
		
		if not os.path.exists(outputPath + "/a25_placeholder/"):
			os.makedirs(outputPath + "/a25_placeholder/")
		
		#creating tile files
		#tileregs.v
		sourceFile = open(amberTilePath + "tile_regs.v", "r")
		oFile = open(outputPath + "tile_regs.v", "w")
		
		for line in sourceFile:
			oFile.write(line)
		
		sourceFile.close()
		oFile.close()
		
		
		#amber_wrapper.v
		sourceFile = open(amberTilePath + "amber_wrapper.v", "r")
		oFile = open(outputPath + "amber_wrapper_" + moduleName +".v", "w")
		
		#find//ACCTAGMOD
		for line in sourceFile:
			if "//ACCTAGMOD" in line:
				break
			oFile.write(line)
		
		oFile.write("module amber_wrapper_" + moduleName + "\n")
		
		#find//ACCTAGMODDONE
		for line in sourceFile:
			if "//ACCTAGMODDONE" in line:
				break
		
		#find//ACCTAGSYS
		for line in sourceFile:
			if "//ACCTAGSYS" in line:
				break
			oFile.write(line)
			
		oFile.write("\tamber_system_" + moduleName + "\n")
		
		#find //ACCTAGSYSDONE				
		for line in sourceFile:
			if "//ACCTAGSYSDONE" in line:
				break
		
		for line in sourceFile:
			oFile.write(line)
		
		sourceFile.close()
		oFile.close()
		
		#amber_tile.vhd
		sourceFile = open(amberTilePath + "amber_tile.vhd", "r")
		oFile = open(outputPath + "amber_tile_" + moduleName +".vhd", "w")
		
		#find --ACCTAGENT
		for line in sourceFile:
			if "--ACCTAGENT" in line:
				break
			oFile.write(line)
			
		oFile.write("entity amber_tile_" + moduleName + " is\n")
		
		#find --ACCTAGENTDONE
		for line in sourceFile:
			if "--ACCTAGENT" in line:
				break
		
		#find --ACCTAGENTEND
		for line in sourceFile:
			if "--ACCTAGENTEND" in line:
				break
			oFile.write(line)
		
		oFile.write("end amber_tile_" + moduleName + ";\n\n")
		oFile.write("architecture rtl of amber_tile_" + moduleName + " is\n\n")
		
		#find --ACCTAGENTENDDONE
		for line in sourceFile:
			if "--ACCTAGENTENDDONE" in line:
				break
		
		#find --ACCTAGWRA
		for line in sourceFile:
			if "--ACCTAGWRA" in line:
				break
			oFile.write(line)
			
		oFile.write("amber_u: amber_wrapper_" + moduleName + "\n")
		
		#find --ACCTAGWRADONE
		for line in sourceFile:
			if "--ACCTAGWRADONE" in line:
				break
		
		for line in sourceFile:
			oFile.write(line)
		
		sourceFile.close()
		oFile.close()
		
		
		### Generate slave IFM
		
		sourceFile = open(amberTilePath + "amber_system.v", "r")
		templateFile = open("templates/slave_TEMP.v", "r")
		oFile = open(outputPath + "slave_" + moduleName +".v", "w")
		wireOutName = "wire [31:0] acc_out_"
		
	
	
		#find #0
		for line in templateFile:
			if "#0" in line:
				break
			oFile.write(line)
		
		#0 found
		oFile.write("//Script generated defines \n")
		oFile.write("`define ACC_INPUTS\t\t" + str(inputsN) + "\n")
		oFile.write("`define ACC_OUTPUTS\t\t" + str(outputsM) + "\n\n")
		
		oFile.write("module IFM_slave_" + moduleName + "\n")
		
		#find #1
		for line in templateFile:
			if "#1" in line:
				break
			oFile.write(line)
		
		#1 found
		for i in range(outputsM):
			oFile.write("\t"+ wireOutName + str(i) +";\n")
		oFile.write("\n")
		oFile.write("\t" + moduleName + " accelerator(\n")
		
		#find #2
		for line in templateFile:
			if "#2" in line:
				break
			oFile.write(line)
			
		#2 found	 
		for i in range(inputsN):
			oFile.write("\t.acc_in_" + str(i) +" (acc_in["+ str(i) +"]),\n")
		for i in range(outputsM):
			oFile.write("\t.acc_out_" + str(i) +" (acc_out_" + str(i))
			if i == (outputsM - 1):
				oFile.write(")\n")
			else:
				oFile.write("),\n")	
		
		#find #3
		for line in templateFile:
			if "#3" in line:
				break
			oFile.write(line)	
		
		#3 found
		for i in range(outputsM):
			oFile.write("\t\tacc_out[" + str(i) +"] <= acc_out_" + str(i) + ";\n")
				
		for line in templateFile:
			oFile.write(line)
		
		oFile.close()
		templateFile.close()
		### slave IFM generation completed
		
		#generate new amber_system file
		templateFile = open("templates/slave_sys_TEMP.v", "r")
		oFile = open(outputPath + "amber_system_slave_" + moduleName +".v", "w")
		
		#find //ACCTAGSYSINST
		for line in sourceFile:
			if "//ACCTAGSYSINST" in line:
				break
			oFile.write(line)
		
		#find //ACCTAGSYSINSTDONE
		for line in sourceFile:
			if "//ACCTAGSYSINSTDONE" in line:
				break
				
		oFile.write("module amber_system_slave_" + moduleName + "\n")
		
		#find //ACCTAGINST
		for line in sourceFile:
			if "//ACCTAGINST" in line:
				break
			oFile.write(line)
			
		#move past lines not to be written
		#find //ACCTAGINSTDONE
		for line in sourceFile:
			if "//ACCTAGINSTDONE" in line:
				break
		
		#move to template file
		#find #0
		for line in templateFile:
			if "#0" in line:
				break
			oFile.write(line)
		
		#0 found
		oFile.write("\t" +"IFM_slave_"+ moduleName + " u_acc_if_slave (\n")
		
		#find #1
		for line in templateFile:
			if "#1" in line:
				break
			oFile.write(line)
		
		#1 found
		#move to source file
		#find //ACCTAGSTBRST
		for line in sourceFile:
			if "//ACCTAGSTBRST" in line:
				break
			oFile.write(line)
			
		oFile.write("      wb_stb_acc = 0;\n")
		
		#find //ACCTAGSTB
		for line in sourceFile:
			if "//ACCTAGSTB" in line:
				break
			oFile.write(line)
		
		for line in templateFile:
			oFile.write(line)
		
		for line in sourceFile:
			oFile.write(line)
		
		sourceFile.close()
		templateFile.close()
		oFile.close()
			
		print("Done!")
		print("Your verilog files can be found in the output folder")
	####################################################
	###  			master IF generate				 ###
	####################################################
	
	elif ifType == "floop":
		outputPath = outputPath + "floopIFM_" + moduleName + "/"
		if not os.path.exists(outputPath):
			os.makedirs(outputPath)
	
		if not os.path.exists(outputPath + "/a25_placeholder/"):
			os.makedirs(outputPath + "/a25_placeholder/")
		
		#creating tile files
		#tileregs.v
		sourceFile = open(amberTilePath + "tile_regs.v", "r")
		oFile = open(outputPath + "tile_regs.v", "w")
		
		for line in sourceFile:
			oFile.write(line)
		
		sourceFile.close()
		oFile.close()
		
		#amber_wrapper.v
		sourceFile = open(amberTilePath + "amber_wrapper.v", "r")
		oFile = open(outputPath + "amber_wrapper_" + moduleName +".v", "w")
		
		#find//ACCTAGMOD
		for line in sourceFile:
			if "//ACCTAGMOD" in line:
				break
			oFile.write(line)
		
		oFile.write("module amber_wrapper_" + moduleName + "\n")
		
		#find//ACCTAGMODDONE
		for line in sourceFile:
			if "//ACCTAGMODDONE" in line:
				break
		
		#find//ACCTAGSYS
		for line in sourceFile:
			if "//ACCTAGSYS" in line:
				break
			oFile.write(line)
			
		oFile.write("\tamber_system_" + moduleName + "\n")
		
		#find //ACCTAGSYSDONE				
		for line in sourceFile:
			if "//ACCTAGSYSDONE" in line:
				break
		
		for line in sourceFile:
			oFile.write(line)
		
		sourceFile.close()
		oFile.close()
		
		#amber_tile.vhd
		sourceFile = open(amberTilePath + "amber_tile.vhd", "r")
		oFile = open(outputPath + "amber_tile_" + moduleName +".vhd", "w")
		
		#find --ACCTAGENT
		for line in sourceFile:
			if "--ACCTAGENT" in line:
				break
			oFile.write(line)
			
		oFile.write("entity amber_tile_" + moduleName + " is\n")
		
		#find --ACCTAGENTDONE
		for line in sourceFile:
			if "--ACCTAGENT" in line:
				break
		
		#find --ACCTAGENTEND
		for line in sourceFile:
			if "--ACCTAGENTEND" in line:
				break
			oFile.write(line)
		
		oFile.write("end amber_tile_" + moduleName + ";\n\n")
		oFile.write("architecture rtl of amber_tile_" + moduleName + " is\n\n")
		
		#find --ACCTAGENTENDDONE
		for line in sourceFile:
			if "--ACCTAGENTENDDONE" in line:
				break
		
		#find --ACCTAGWRA
		for line in sourceFile:
			if "--ACCTAGWRA" in line:
				break
			oFile.write(line)
			
		oFile.write("amber_u: amber_wrapper_" + moduleName + "\n")
		
		#find --ACCTAGWRADONE
		for line in sourceFile:
			if "--ACCTAGWRADONE" in line:
				break
		
		for line in sourceFile:
			oFile.write(line)
		
		sourceFile.close()
		oFile.close()
		
		### Generate For loop IFM
		
		templateFile = open("templates/floop_TEMP.v", "r")
		oFile = open(outputPath+"floop_" + moduleName +".v", "w")
		wireName = "\twire [31:0] buf_acc_"
		
		
		
		oFile.write("module IFM_floop_" + moduleName + "\n")
		
		#find #0
		for line in templateFile:
			if "#0" in line:
				break
			oFile.write(line)
		
		#0 found
		oFile.write("//script generated output wires\n")
		for i in range(inputsN):
			oFile.write(wireName +"in_" +str(i)+";\n")
		for i in range(outputsM):
			oFile.write(wireName +"out_"+str(i)+";\n")
		
		oFile.write("\n")
		oFile.write("\twbm_buffer_" + moduleName + " wbm_buffer(\n")
		
		#find #1
		for line in templateFile:
			if "#1" in line:
				break
			oFile.write(line)
	#1
	
		for i in range(inputsN):
			oFile.write("\t\t.acc_in_" + str(i) +" (buf_acc_in_"+ str(i) +"),\n")
		for i in range(outputsM):
			oFile.write("\t\t.acc_out_" + str(i) +" (buf_acc_out_" + str(i))
			if i == (outputsM - 1):
				oFile.write(")\n")
			else:
				oFile.write("),\n")	
		
		oFile.write("\t);\n")
		oFile.write("\n")
		oFile.write("\t" + moduleName + " accelerator(\n")
		
		#find #2
		for line in templateFile:
			if "#2" in line:
				break
			oFile.write(line)
		
		#2
		for i in range(inputsN):
			oFile.write("\t\t.acc_in_" + str(i) +" (buf_acc_in_"+ str(i) +"),\n")
		for i in range(outputsM):
			oFile.write("\t\t.acc_out_" + str(i) +" (buf_acc_out_" + str(i))
			if i == (outputsM - 1):
				oFile.write(")\n")
			else:
				oFile.write("),\n")
				
		for line in templateFile:
			oFile.write(line)
		
		###Floop IFM finished!
		
		oFile.close()
		templateFile.close()
		
		###generating wb buffer
		
		oFile = open(outputPath +"wb_buffer_" + moduleName +".v", "w")
		templateFile = open("templates/wb_buffer_TEMP.v", "r")
		
		oFile.write("//Script generated defines \n")
		oFile.write("`define ACC_INPUTS\t\t" + str(inputsN) + "\n")
		oFile.write("`define ACC_OUTPUTS\t\t" + str(outputsM) + "\n\n")
		
		if(inputsN > 4):
			oFile.write("`define OUTQUEUESIZE\t\t" + str(inputsN*2) + "\n")
		else:
			oFile.write("`define OUTQUEUESIZE\t\t" + str(8) + "\n")
			
		if(outputsM > 4):
			oFile.write("`define INQUEUESIZE\t\t" + str(outputsM*2) + "\n\n")
		else:
			oFile.write("`define INQUEUESIZE\t\t" + str(8) + "\n\n")
			
		oFile.write("module wbm_buffer_" + moduleName + "\n")
			
		#find #0
		for line in templateFile:
			if "#0" in line:
				break
			oFile.write(line)
		#0
		for i in range(inputsN):
			oFile.write("\toutput reg\t[31:0]\tacc_in_" + str(i) +",\n")
		for i in range(outputsM):
			oFile.write("\tinput\t\t[31:0]\tacc_out_" + str(i))
			if i == (outputsM - 1):
				oFile.write("\n")
			else:
				oFile.write(",\n")	
		
		#find #1
		for line in templateFile:
			if "#1" in line:
				break
			oFile.write(line)
			
		#1
		for i in range(inputsN):
			oFile.write("\t\t\t\t\tacc_in_" + str(i) +" <= input_fifo[" + str(i) + "];\n")
		
		#find #2
		for line in templateFile:
			if "#2" in line:
				break
			oFile.write(line)
		#2
		for i in range(outputsM):
			oFile.write("\t\t\t\t\toutput_buffer[" + str(i) + "] = acc_out_" + str(i) + ";\n")
			
		for line in templateFile:
			oFile.write(line)
		
		###wb buffer completed!
		
		oFile.close()
		templateFile.close()
		
		###generating amber_system
		oFile = open(outputPath +"amber_system_Floop_" + moduleName +".v", "w")
		templateFile = open("templates/Floop_sys_TEMP.v", "r")
		
		
		
		#find #0
		for line in templateFile:
			if "#0" in line:
				break
			oFile.write(line)
		
		oFile.write("module amber_system_floop_" + moduleName + "\n")
		
		#find #1
		for line in templateFile:
			if "#1" in line:
				break
			oFile.write(line)
		
		oFile.write("\tIFM_floop_" + moduleName + " IFM_floop\n")
		for line in templateFile:
			oFile.write(line)
			
		###Floop IFM finished!
		oFile.close()
		templateFile.close()
		print("Done!")
		print("Your verilog files can be found in the output folder")
	##Unknown ifType
	else:
		print("ifType not recognized")
	

main(sys.argv[1:])
	
